Index: branches/1.3/gui/scripts/flowvisviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/flowvisviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/flowvisviewer.tcl	(revision 4750)
@@ -1146,8 +1146,9 @@
             if { $_reportClientInfo }  {
                 set info {}
-                lappend info "tool_id"       [$dataobj hints toolId]
-                lappend info "tool_name"     [$dataobj hints toolName]
-                lappend info "tool_version"  [$dataobj hints toolRevision]
-                lappend info "tool_title"    [$dataobj hints toolTitle]
+                lappend info "tool_id"       [$dataobj hints toolid]
+                lappend info "tool_name"     [$dataobj hints toolname]
+                lappend info "tool_title"    [$dataobj hints tooltitle]
+                lappend info "tool_command"  [$dataobj hints toolcommand]
+                lappend info "tool_revision" [$dataobj hints toolrevision]
                 lappend info "dataset_label" [$dataobj hints label]
                 lappend info "dataset_size"  $nbytes
Index: branches/1.3/gui/scripts/mapviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/mapviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/mapviewer.tcl	(revision 4750)
@@ -986,8 +986,9 @@
                 if { $_reportClientInfo }  {
                     set cinfo {}
-                    lappend cinfo "tool_id"       [$dataobj hints toolId]
-                    lappend cinfo "tool_name"     [$dataobj hints toolName]
-                    lappend cinfo "tool_version"  [$dataobj hints toolRevision]
-                    lappend cinfo "tool_title"    [$dataobj hints toolTitle]
+                    lappend cinfo "tool_id"       [$dataobj hints toolid]
+                    lappend cinfo "tool_name"     [$dataobj hints toolname]
+                    lappend cinfo "tool_title"    [$dataobj hints tooltitle]
+                    lappend cinfo "tool_command"  [$dataobj hints toolcommand]
+                    lappend cinfo "tool_revision" [$dataobj hints toolrevision]
                     lappend cinfo "dataset_label" [$dataobj hints label]
                     lappend cinfo "dataset_tag"   $layer
Index: branches/1.3/gui/scripts/nanovisviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4750)
@@ -922,8 +922,9 @@
                 if { $_reportClientInfo }  {
                     set info {}
-                    lappend info "tool_id"       [$dataobj hints toolId]
-                    lappend info "tool_name"     [$dataobj hints toolName]
-                    lappend info "tool_version"  [$dataobj hints toolRevision]
-                    lappend info "tool_title"    [$dataobj hints toolTitle]
+                    lappend info "tool_id"       [$dataobj hints toolid]
+                    lappend info "tool_name"     [$dataobj hints toolname]
+                    lappend info "tool_title"    [$dataobj hints tooltitle]
+                    lappend info "tool_command"  [$dataobj hints toolcommand]
+                    lappend info "tool_revision" [$dataobj hints toolrevision]
                     lappend info "dataset_label" [$dataobj hints label]
                     lappend info "dataset_size"  $nbytes
Index: branches/1.3/gui/scripts/vtkglyphviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkglyphviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/vtkglyphviewer.tcl	(revision 4750)
@@ -979,8 +979,9 @@
                 if { $_reportClientInfo }  {
                     set info {}
-                    lappend info "tool_id"       [$dataobj hints toolId]
-                    lappend info "tool_name"     [$dataobj hints toolName]
-                    lappend info "tool_version"  [$dataobj hints toolRevision]
-                    lappend info "tool_title"    [$dataobj hints toolTitle]
+                    lappend info "tool_id"       [$dataobj hints toolid]
+                    lappend info "tool_name"     [$dataobj hints toolname]
+                    lappend info "tool_title"    [$dataobj hints tooltitle]
+                    lappend info "tool_command"  [$dataobj hints toolcommand]
+                    lappend info "tool_revision" [$dataobj hints toolrevision]
                     lappend info "dataset_label" [$dataobj hints label]
                     lappend info "dataset_size"  $length
Index: branches/1.3/gui/scripts/vtkheightmapviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkheightmapviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/vtkheightmapviewer.tcl	(revision 4750)
@@ -987,8 +987,9 @@
                 if { $_reportClientInfo }  {
                     set info {}
-                    lappend info "tool_id"       [$dataobj hints toolId]
-                    lappend info "tool_name"     [$dataobj hints toolName]
-                    lappend info "tool_version"  [$dataobj hints toolRevision]
-                    lappend info "tool_title"    [$dataobj hints toolTitle]
+                    lappend info "tool_id"       [$dataobj hints toolid]
+                    lappend info "tool_name"     [$dataobj hints toolname]
+                    lappend info "tool_title"    [$dataobj hints tooltitle]
+                    lappend info "tool_command"  [$dataobj hints toolcommand]
+                    lappend info "tool_revision" [$dataobj hints toolrevision]
                     lappend info "dataset_label" [$dataobj hints label]
                     lappend info "dataset_size"  $length
Index: branches/1.3/gui/scripts/vtkimageviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkimageviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/vtkimageviewer.tcl	(revision 4750)
@@ -963,8 +963,9 @@
                 if { $_reportClientInfo }  {
                     set info {}
-                    lappend info "tool_id"       [$dataobj hints toolId]
-                    lappend info "tool_name"     [$dataobj hints toolName]
-                    lappend info "tool_version"  [$dataobj hints toolRevision]
-                    lappend info "tool_title"    [$dataobj hints toolTitle]
+                    lappend info "tool_id"       [$dataobj hints toolid]
+                    lappend info "tool_name"     [$dataobj hints toolname]
+                    lappend info "tool_title"    [$dataobj hints tooltitle]
+                    lappend info "tool_command"  [$dataobj hints toolcommand]
+                    lappend info "tool_revision" [$dataobj hints toolrevision]
                     lappend info "dataset_label" [$dataobj hints label]
                     lappend info "dataset_size"  $length
Index: branches/1.3/gui/scripts/vtkisosurfaceviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkisosurfaceviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/vtkisosurfaceviewer.tcl	(revision 4750)
@@ -1023,8 +1023,9 @@
                 if { $_reportClientInfo }  {
                     set info {}
-                    lappend info "tool_id"       [$dataobj hints toolId]
-                    lappend info "tool_name"     [$dataobj hints toolName]
-                    lappend info "tool_version"  [$dataobj hints toolRevision]
-                    lappend info "tool_title"    [$dataobj hints toolTitle]
+                    lappend info "tool_id"       [$dataobj hints toolid]
+                    lappend info "tool_name"     [$dataobj hints toolname]
+                    lappend info "tool_title"    [$dataobj hints tooltitle]
+                    lappend info "tool_command"  [$dataobj hints toolcommand]
+                    lappend info "tool_revision" [$dataobj hints toolrevision]
                     lappend info "dataset_label" [$dataobj hints label]
                     lappend info "dataset_size"  $length
Index: branches/1.3/gui/scripts/vtkmeshviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkmeshviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/vtkmeshviewer.tcl	(revision 4750)
@@ -847,8 +847,9 @@
             if { $_reportClientInfo }  {
                 set info {}
-                lappend info "tool_id"       [$dataobj hints toolId]
-                lappend info "tool_name"     [$dataobj hints toolName]
-                lappend info "tool_version"  [$dataobj hints toolRevision]
-                lappend info "tool_title"    [$dataobj hints toolTitle]
+                lappend info "tool_id"       [$dataobj hints toolid]
+                lappend info "tool_name"     [$dataobj hints toolname]
+                lappend info "tool_title"    [$dataobj hints tooltitle]
+                lappend info "tool_command"  [$dataobj hints toolcommand]
+                lappend info "tool_revision" [$dataobj hints toolrevision]
                 lappend info "dataset_label" [$dataobj hints label]
                 lappend info "dataset_size"  $length
Index: branches/1.3/gui/scripts/vtkstreamlinesviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkstreamlinesviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/vtkstreamlinesviewer.tcl	(revision 4750)
@@ -998,8 +998,9 @@
                 if { $_reportClientInfo }  {
                     set info {}
-                    lappend info "tool_id"       [$dataobj hints toolId]
-                    lappend info "tool_name"     [$dataobj hints toolName]
-                    lappend info "tool_version"  [$dataobj hints toolRevision]
-                    lappend info "tool_title"    [$dataobj hints toolTitle]
+                    lappend info "tool_id"       [$dataobj hints toolid]
+                    lappend info "tool_name"     [$dataobj hints toolname]
+                    lappend info "tool_title"    [$dataobj hints tooltitle]
+                    lappend info "tool_command"  [$dataobj hints toolcommand]
+                    lappend info "tool_revision" [$dataobj hints toolrevision]
                     lappend info "dataset_label" [$dataobj hints label]
                     lappend info "dataset_size"  $length
Index: branches/1.3/gui/scripts/vtksurfaceviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtksurfaceviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/vtksurfaceviewer.tcl	(revision 4750)
@@ -934,8 +934,9 @@
                 if { $_reportClientInfo }  {
                     set info {}
-                    lappend info "tool_id"       [$dataobj hints toolId]
-                    lappend info "tool_name"     [$dataobj hints toolName]
-                    lappend info "tool_version"  [$dataobj hints toolRevision]
-                    lappend info "tool_title"    [$dataobj hints toolTitle]
+                    lappend info "tool_id"       [$dataobj hints toolid]
+                    lappend info "tool_name"     [$dataobj hints toolname]
+                    lappend info "tool_title"    [$dataobj hints tooltitle]
+                    lappend info "tool_command"  [$dataobj hints toolcommand]
+                    lappend info "tool_revision" [$dataobj hints toolrevision]
                     lappend info "dataset_label" [$dataobj hints label]
                     lappend info "dataset_size"  $length
Index: branches/1.3/gui/scripts/vtkviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/vtkviewer.tcl	(revision 4750)
@@ -1060,8 +1060,9 @@
                 if { $_reportClientInfo }  {
                     set info {}
-                    lappend info "tool_id"       [$dataobj hints toolId]
-                    lappend info "tool_name"     [$dataobj hints toolName]
-                    lappend info "tool_version"  [$dataobj hints toolRevision]
-                    lappend info "tool_title"    [$dataobj hints toolTitle]
+                    lappend info "tool_id"       [$dataobj hints toolid]
+                    lappend info "tool_name"     [$dataobj hints toolname]
+                    lappend info "tool_title"    [$dataobj hints tooltitle]
+                    lappend info "tool_command"  [$dataobj hints toolcommand]
+                    lappend info "tool_revision" [$dataobj hints toolrevision]
                     lappend info "dataset_label" [$dataobj hints label]
                     lappend info "dataset_size"  $length
Index: branches/1.3/gui/scripts/vtkvolumeviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkvolumeviewer.tcl	(revision 4748)
+++ branches/1.3/gui/scripts/vtkvolumeviewer.tcl	(revision 4750)
@@ -978,8 +978,9 @@
                 if { $_reportClientInfo }  {
                     set info {}
-                    lappend info "tool_id"       [$dataobj hints toolId]
-                    lappend info "tool_name"     [$dataobj hints toolName]
-                    lappend info "tool_version"  [$dataobj hints toolRevision]
-                    lappend info "tool_title"    [$dataobj hints toolTitle]
+                    lappend info "tool_id"       [$dataobj hints toolid]
+                    lappend info "tool_name"     [$dataobj hints toolname]
+                    lappend info "tool_title"    [$dataobj hints tooltitle]
+                    lappend info "tool_command"  [$dataobj hints toolcommand]
+                    lappend info "tool_revision" [$dataobj hints toolrevision]
                     lappend info "dataset_label" [$dataobj hints label]
                     lappend info "dataset_size"  $length