Index: /tags/1.3.5/configure
===================================================================
--- /tags/1.3.5/configure	(revision 4753)
+++ /tags/1.3.5/configure	(revision 4754)
@@ -671,4 +671,5 @@
 OCTAVE_VERSION_MAJOR
 OCTAVE_VERSION
+SVN_URL
 SVN_VERSION
 MKOCTFILE3
@@ -7292,4 +7293,5 @@
 
 SVN_VERSION=`svnversion $srcdir`
+SVN_URL=`svn info $srcdir | sed -ne 's/^URL: //p'`
 
 make_command=""
@@ -10100,4 +10102,5 @@
 
 MAKE=${make_command}
+
 
 
Index: /tags/1.3.5/configure.in
===================================================================
--- /tags/1.3.5/configure.in	(revision 4753)
+++ /tags/1.3.5/configure.in	(revision 4754)
@@ -108,4 +108,5 @@
 
 SVN_VERSION=`svnversion $srcdir`
+SVN_URL=`svn info $srcdir | sed -ne 's/^URL: //p'`
 
 make_command=""
@@ -375,4 +376,5 @@
 AC_SUBST(MKOCTFILE3)
 AC_SUBST(SVN_VERSION)
+AC_SUBST(SVN_URL)
 AC_SUBST(OCTAVE_VERSION)
 AC_SUBST(OCTAVE_VERSION_MAJOR)
Index: /tags/1.3.5/gui/scripts/flowvisviewer.tcl
===================================================================
--- /tags/1.3.5/gui/scripts/flowvisviewer.tcl	(revision 4753)
+++ /tags/1.3.5/gui/scripts/flowvisviewer.tcl	(revision 4754)
@@ -869,4 +869,8 @@
                 set session $env(SESSION)
 	    }
+            lappend info "version" "$Rappture::version"
+            lappend info "build" "$Rappture::build"
+            lappend info "svnurl" "$Rappture::svnurl"
+            lappend info "installdir" "$Rappture::installdir"
             lappend info "hub" [exec hostname]
             lappend info "client" "flowvisviewer"
Index: /tags/1.3.5/gui/scripts/molvisviewer.tcl
===================================================================
--- /tags/1.3.5/gui/scripts/molvisviewer.tcl	(revision 4753)
+++ /tags/1.3.5/gui/scripts/molvisviewer.tcl	(revision 4754)
@@ -691,4 +691,8 @@
                 set session $env(SESSION)
 	    }
+            lappend info "version" "$Rappture::version"
+            lappend info "build" "$Rappture::build"
+            lappend info "svnurl" "$Rappture::svnurl"
+            lappend info "installdir" "$Rappture::installdir"
             lappend info "hub" [exec hostname]
             lappend info "client" "molvisviewer"
Index: /tags/1.3.5/gui/scripts/nanovisviewer.tcl
===================================================================
--- /tags/1.3.5/gui/scripts/nanovisviewer.tcl	(revision 4753)
+++ /tags/1.3.5/gui/scripts/nanovisviewer.tcl	(revision 4754)
@@ -615,4 +615,8 @@
                 set session $env(SESSION)
             }
+            lappend info "version" "$Rappture::version"
+            lappend info "build" "$Rappture::build"
+            lappend info "svnurl" "$Rappture::svnurl"
+            lappend info "installdir" "$Rappture::installdir"
             lappend info "hub" [exec hostname]
             lappend info "client" "nanovisviewer"
Index: /tags/1.3.5/gui/scripts/vtkglyphviewer.tcl
===================================================================
--- /tags/1.3.5/gui/scripts/vtkglyphviewer.tcl	(revision 4753)
+++ /tags/1.3.5/gui/scripts/vtkglyphviewer.tcl	(revision 4754)
@@ -778,4 +778,8 @@
                 set session $env(SESSION)
             }
+            lappend info "version" "$Rappture::version"
+            lappend info "build" "$Rappture::build"
+            lappend info "svnurl" "$Rappture::svnurl"
+            lappend info "installdir" "$Rappture::installdir"
             lappend info "hub" [exec hostname]
             lappend info "client" "vtkglyphviewer"
Index: /tags/1.3.5/gui/scripts/vtkheightmapviewer.tcl
===================================================================
--- /tags/1.3.5/gui/scripts/vtkheightmapviewer.tcl	(revision 4753)
+++ /tags/1.3.5/gui/scripts/vtkheightmapviewer.tcl	(revision 4754)
@@ -767,4 +767,8 @@
                 set session $env(SESSION)
             }
+            lappend info "version" "$Rappture::version"
+            lappend info "build" "$Rappture::build"
+            lappend info "svnurl" "$Rappture::svnurl"
+            lappend info "installdir" "$Rappture::installdir"
             lappend info "hub" [exec hostname]
             lappend info "client" "vtkheightmapviewer"
Index: /tags/1.3.5/gui/scripts/vtkisosurfaceviewer.tcl
===================================================================
--- /tags/1.3.5/gui/scripts/vtkisosurfaceviewer.tcl	(revision 4753)
+++ /tags/1.3.5/gui/scripts/vtkisosurfaceviewer.tcl	(revision 4754)
@@ -825,4 +825,5 @@
             lappend info "version" "$Rappture::version"
             lappend info "build" "$Rappture::build"
+            lappend info "svnurl" "$Rappture::svnurl"
             lappend info "installdir" "$Rappture::installdir"
             lappend info "hub" [exec hostname]
Index: /tags/1.3.5/gui/scripts/vtkstreamlinesviewer.tcl
===================================================================
--- /tags/1.3.5/gui/scripts/vtkstreamlinesviewer.tcl	(revision 4753)
+++ /tags/1.3.5/gui/scripts/vtkstreamlinesviewer.tcl	(revision 4754)
@@ -800,4 +800,8 @@
                 set session $env(SESSION)
 	    }
+            lappend info "version" "$Rappture::version"
+            lappend info "build" "$Rappture::build"
+            lappend info "svnurl" "$Rappture::svnurl"
+            lappend info "installdir" "$Rappture::installdir"
             lappend info "hub" [exec hostname]
             lappend info "client" "vtkstreamlinesviewer"
Index: /tags/1.3.5/gui/scripts/vtkviewer.tcl
===================================================================
--- /tags/1.3.5/gui/scripts/vtkviewer.tcl	(revision 4753)
+++ /tags/1.3.5/gui/scripts/vtkviewer.tcl	(revision 4754)
@@ -840,4 +840,8 @@
                 set session $env(SESSION)
             }
+            lappend info "version" "$Rappture::version"
+            lappend info "build" "$Rappture::build"
+            lappend info "svnurl" "$Rappture::svnurl"
+            lappend info "installdir" "$Rappture::installdir"
             lappend info "hub" [exec hostname]
             lappend info "client" "vtkviewer"
Index: /tags/1.3.5/gui/scripts/vtkvolumeviewer.tcl
===================================================================
--- /tags/1.3.5/gui/scripts/vtkvolumeviewer.tcl	(revision 4753)
+++ /tags/1.3.5/gui/scripts/vtkvolumeviewer.tcl	(revision 4754)
@@ -763,4 +763,8 @@
                 set session $env(SESSION)
             }
+            lappend info "version" "$Rappture::version"
+            lappend info "build" "$Rappture::build"
+            lappend info "svnurl" "$Rappture::svnurl"
+            lappend info "installdir" "$Rappture::installdir"
             lappend info "hub" [exec hostname]
             lappend info "client" "vtkvolumeviewer"
Index: /tags/1.3.5/lang/tcl/pkgIndex.tcl.in
===================================================================
--- /tags/1.3.5/lang/tcl/pkgIndex.tcl.in	(revision 4753)
+++ /tags/1.3.5/lang/tcl/pkgIndex.tcl.in	(revision 4754)
@@ -6,4 +6,5 @@
 	variable version $version
 	variable build "@SVN_VERSION@"
+	variable svnurl "@SVN_URL@"
 	variable installdir [file normalize $dir]
     }