Index: branches/1.3/gui/scripts/flowvisviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/flowvisviewer.tcl	(revision 4750)
+++ branches/1.3/gui/scripts/flowvisviewer.tcl	(revision 4759)
@@ -2308,5 +2308,7 @@
         entry $inner.${tag} -font "Arial 9"  -bg white \
             -textvariable [itcl::scope _settings($this-$tag)]
-        bind $inner.${tag} <KeyPress-Return> \
+        bind $inner.${tag} <Return> \
+            [itcl::code $this camera set ${tag}]
+        bind $inner.${tag} <KP_Enter> \
             [itcl::code $this camera set ${tag}]
         blt::table $inner \
Index: branches/1.3/gui/scripts/vtkglyphviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkglyphviewer.tcl	(revision 4750)
+++ branches/1.3/gui/scripts/vtkglyphviewer.tcl	(revision 4759)
@@ -1759,5 +1759,7 @@
         entry $inner.${tag} -font "Arial 9"  -bg white \
             -textvariable [itcl::scope _view($tag)]
-        bind $inner.${tag} <KeyPress-Return> \
+        bind $inner.${tag} <Return> \
+            [itcl::code $this camera set ${tag}]
+        bind $inner.${tag} <KP_Enter> \
             [itcl::code $this camera set ${tag}]
         blt::table $inner \
Index: branches/1.3/gui/scripts/vtkheightmapviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkheightmapviewer.tcl	(revision 4750)
+++ branches/1.3/gui/scripts/vtkheightmapviewer.tcl	(revision 4759)
@@ -1071,5 +1071,7 @@
 
 	    if {$axis == "z" && [$_first hints ${axis}units] == ""} {
-		set units [lindex $_fields($_curFldName) 1]
+                if {$_curFldName != ""} {
+                    set units [lindex $_fields($_curFldName) 1]
+                }
 	    } else {
 		set units [$_first hints ${axis}units]
@@ -1716,5 +1718,6 @@
     if { $_currentColormap != ""  } {
 	set cmap $_currentColormap
-	SendCmd "legend $cmap scalar $_curFldName {} $w $h 0"
+	#SendCmd "legend $cmap scalar $_curFldName {} $w $h 0"
+        SendCmd "legend2 $cmap $w $h"
     }
 }
Index: branches/1.3/gui/scripts/vtkimageviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkimageviewer.tcl	(revision 4750)
+++ branches/1.3/gui/scripts/vtkimageviewer.tcl	(revision 4759)
@@ -1030,5 +1030,7 @@
 
 	    if {$axis == "z" && [$_first hints ${axis}units] == ""} {
-		set units [lindex $_fields($_curFldName) 1]
+                if {$_curFldName != ""} {
+                    set units [lindex $_fields($_curFldName) 1]
+                }
 	    } else {
 		set units [$_first hints ${axis}units]
@@ -1552,5 +1554,6 @@
     # Set the legend on the first image dataset.
     if { $_currentColormap != "" && $_currentColormap != "none" } {
-	SendCmd "legend $_currentColormap scalar $_curFldName {} $w $h 0"
+	#SendCmd "legend $_currentColormap scalar $_curFldName {} $w $h 0"
+        SendCmd "legend2 $_currentColormap $w $h"
     }
 }
Index: branches/1.3/gui/scripts/vtkisosurfaceviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkisosurfaceviewer.tcl	(revision 4750)
+++ branches/1.3/gui/scripts/vtkisosurfaceviewer.tcl	(revision 4759)
@@ -1840,6 +1840,8 @@
         entry $inner.${tag} -font "Arial 9"  -bg white \
             -textvariable [itcl::scope _view(-$tag)]
-        bind $inner.${tag} <KeyPress-Return> \
-            [itcl::code $this camera set ${tag}]
+        bind $inner.${tag} <Return> \
+            [itcl::code $this camera set -${tag}]
+        bind $inner.${tag} <KP_Enter> \
+            [itcl::code $this camera set -${tag}]
         blt::table $inner \
             $row,0 $inner.${tag}label -anchor e -pady 2 \
Index: branches/1.3/gui/scripts/vtkmeshviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkmeshviewer.tcl	(revision 4750)
+++ branches/1.3/gui/scripts/vtkmeshviewer.tcl	(revision 4759)
@@ -1443,5 +1443,7 @@
         entry $inner.${tag} -font "Arial 9"  -bg white \
             -textvariable [itcl::scope _view($tag)]
-        bind $inner.${tag} <KeyPress-Return> \
+        bind $inner.${tag} <Return> \
+            [itcl::code $this camera set ${tag}]
+        bind $inner.${tag} <KP_Enter> \
             [itcl::code $this camera set ${tag}]
         blt::table $inner \
Index: branches/1.3/gui/scripts/vtkstreamlinesviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkstreamlinesviewer.tcl	(revision 4750)
+++ branches/1.3/gui/scripts/vtkstreamlinesviewer.tcl	(revision 4759)
@@ -1870,5 +1870,7 @@
         entry $inner.${tag} -font "Arial 9"  -bg white \
             -textvariable [itcl::scope _view($tag)]
-        bind $inner.${tag} <KeyPress-Return> \
+        bind $inner.${tag} <Return> \
+            [itcl::code $this camera set ${tag}]
+        bind $inner.${tag} <KP_Enter> \
             [itcl::code $this camera set ${tag}]
         blt::table $inner \
Index: branches/1.3/gui/scripts/vtksurfaceviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtksurfaceviewer.tcl	(revision 4750)
+++ branches/1.3/gui/scripts/vtksurfaceviewer.tcl	(revision 4759)
@@ -1752,5 +1752,7 @@
         entry $inner.${tag} -font "Arial 9"  -bg white \
             -textvariable [itcl::scope _view($tag)]
-        bind $inner.${tag} <KeyPress-Return> \
+        bind $inner.${tag} <Return> \
+            [itcl::code $this camera set ${tag}]
+        bind $inner.${tag} <KP_Enter> \
             [itcl::code $this camera set ${tag}]
         blt::table $inner \
Index: branches/1.3/gui/scripts/vtkviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkviewer.tcl	(revision 4750)
+++ branches/1.3/gui/scripts/vtkviewer.tcl	(revision 4759)
@@ -2224,5 +2224,7 @@
         entry $inner.${tag} -font "Arial 9"  -bg white \
             -textvariable [itcl::scope _view($tag)]
-        bind $inner.${tag} <KeyPress-Return> \
+        bind $inner.${tag} <Return> \
+            [itcl::code $this camera set ${tag}]
+        bind $inner.${tag} <KP_Enter> \
             [itcl::code $this camera set ${tag}]
         blt::table $inner \