Index: branches/r9/lang/R/Makefile.in
===================================================================
--- branches/r9/lang/R/Makefile.in	(revision 4853)
+++ branches/r9/lang/R/Makefile.in	(revision 4861)
@@ -21,6 +21,4 @@
 R               = @R@
 
-coresrcdir      = `pwd`/$(srcdir)/../../src/core
-corelibdir      = `pwd`/../../src/core
 R_flags         = --configure-args='--with-rappture-include=$(includedir)  \
                                     --with-rappture-lib=$(libdir)'
Index: branches/r9/lang/java/Makefile.in
===================================================================
--- branches/r9/lang/java/Makefile.in	(revision 4853)
+++ branches/r9/lang/java/Makefile.in	(revision 4861)
@@ -43,6 +43,6 @@
 RM		= rm -f
 
-INCLUDES	= $(JAVA_INCLUDES) -I $(srcdir)/../../src/core -I .
-LIBS		= -L../../src/core -lrappture
+INCLUDES	= $(JAVA_INCLUDES) -I$(includedir) -I .
+LIBS		= -L$(libdir) -lrappture
 
 CC_SWITCHES     = $(CFLAGS) $(CFLAGS_DEBUG) $(SHLIB_CFLAGS) $(INCLUDES) $(DEFINES)
Index: branches/r9/lang/matlab/Makefile.in
===================================================================
--- branches/r9/lang/matlab/Makefile.in	(revision 4853)
+++ branches/r9/lang/matlab/Makefile.in	(revision 4861)
@@ -24,9 +24,8 @@
 matlabdir	= $$RAPPTURE_INSTALL_DIR/lib/matlab
 
-INCLUDES  	= \
-		-I$(srcdir)/../../src/core \
-		-I$(prefix)/include 
+INCLUDES  	= -I$(includedir) 
+
 DEFINES		= -g 
-LIBS		=  -L../../src/core -L$(libdir) -lrappture
+LIBS		= -L$(libdir) -lrappture
 
 MEX_FLAGS	= $(MEX_ARCH) $(INCLUDES) $(DEFINES)
Index: branches/r9/lang/octave/octave2/Makefile.in
===================================================================
--- branches/r9/lang/octave/octave2/Makefile.in	(revision 4853)
+++ branches/r9/lang/octave/octave2/Makefile.in	(revision 4861)
@@ -20,8 +20,7 @@
 INCLUDES    = \
 		-I$(srcdir) \
-		-I$(srcdir)/../../../src/core \
-		-I$(prefix)/include
+		-I$(includedir) 
 DEFINES     =
-LIBS        = -L../../../src/core -lrappture
+LIBS        = -L$(libdir) -lrappture
 OCT_FLAGS   = $(INCLUDES) $(DEFINES)
 
Index: branches/r9/lang/octave/octave3/Makefile.in
===================================================================
--- branches/r9/lang/octave/octave3/Makefile.in	(revision 4853)
+++ branches/r9/lang/octave/octave3/Makefile.in	(revision 4861)
@@ -20,8 +20,7 @@
 INCLUDES    = \
 		-I$(srcdir) \
-		-I$(srcdir)/../../../src/core \
-		-I$(prefix)/include
+		-I$(includedir) 
 DEFINES     =
-LIBS        = -L../../../src/core -lrappture
+LIBS        = -L$(libdir) -lrappture
 OCT_FLAGS   = $(INCLUDES) $(DEFINES)
 
Index: branches/r9/lang/perl/Makefile.PL.in
===================================================================
--- branches/r9/lang/perl/Makefile.PL.in	(revision 4853)
+++ branches/r9/lang/perl/Makefile.PL.in	(revision 4861)
@@ -21,5 +21,5 @@
                      );
     }
-    @RAPPTURE_INC_SEARCHPATH = ( "@srcdir@/../../src/core", "@prefix@/include",
+    @RAPPTURE_INC_SEARCHPATH = ( "@prefix@/include",
         "../include", "/usr/local/include", "/opt/include");
     $RAPPTURE_INC = "rappture.h";
@@ -29,5 +29,5 @@
         "/opt/expat-2.0.0/lib", "/opt/expat/lib" );
     $EXPAT_INC="expat.h";
-    @RAPPTURE_LIB_SEARCHPATH = ( "../../../src/core", "@prefix@/lib",
+    @RAPPTURE_LIB_SEARCHPATH = ( "@prefix@/lib",
         "@libdir@",
         "../src", "/usr/local/lib", "/opt/lib" );
Index: branches/r9/lang/perl/Makefile.in
===================================================================
--- branches/r9/lang/perl/Makefile.in	(revision 4853)
+++ branches/r9/lang/perl/Makefile.in	(revision 4861)
@@ -60,9 +60,9 @@
 INCLUDES	= \
 		-I$(srcdir) \
-		-I$(srcdir)/../../src/core \
+		-I$(includedir) \
 		-I$(archlibexp)/CORE
 
 LIBS		= \
-		-L../../src/core -lrappture \
+		-L$(libdir) -lrappture \
 		$(PERL_LIBSPEC) \
 		-lexpat 
Index: branches/r9/lang/python/Makefile.in
===================================================================
--- branches/r9/lang/python/Makefile.in	(revision 4853)
+++ branches/r9/lang/python/Makefile.in	(revision 4861)
@@ -24,6 +24,6 @@
 PYTHON_VERSION  = @PYTHON_VERSION@
 
-python_flags    = --library-dirs=$(libdir):../../src/core \
-                  --include-dirs=$(srcdir)/../../src/core:$(PYTHON_INCDIR)
+python_flags    = --library-dirs=$(libdir) \
+                  --include-dirs=$(includedir):$(PYTHON_INCDIR)
 pythonlib       = $(libdir)/python$(PYTHON_VERSION)/site-packages
 envfile         = python.env
Index: branches/r9/lang/python/setup.py.in
===================================================================
--- branches/r9/lang/python/setup.py.in	(revision 4853)
+++ branches/r9/lang/python/setup.py.in	(revision 4861)
@@ -4,6 +4,6 @@
 tmpdir = 'build/tmp/'
 srcdir = '@srcdir@/Rappture/'
-incdir = '@srcdir@/../../src/core'
-libdir = '@srcdir@/../../src/core'
+incdir = '@includedir@'
+libdir = '@libdir@'
 
 library_module = Extension('Rappture.library',
Index: branches/r9/lang/ruby/Makefile.in
===================================================================
--- branches/r9/lang/ruby/Makefile.in	(revision 4853)
+++ branches/r9/lang/ruby/Makefile.in	(revision 4861)
@@ -36,5 +36,4 @@
 CFLAGS          = @CFLAGS@ @SHLIB_CFLAGS@
 INCLUDES        = -I$(srcdir) \
-		  -I$(srcdir)/../../src/core \
 		  -I$(includedir) \
 		  $(RUBY_CPPFLAGS)
@@ -49,5 +48,5 @@
 
 LIBS            = \
-		-L../../src/core -lrappture \
+		-L$(libdir) -lrappture \
 		$(RUBY_LIBRUBYARG)
 
Index: branches/r9/lang/ruby/build.rb.in
===================================================================
--- branches/r9/lang/ruby/build.rb.in	(revision 4853)
+++ branches/r9/lang/ruby/build.rb.in	(revision 4861)
@@ -11,4 +11,6 @@
 cxxflags      = "@CXXFLAGS@"
 srcdir	      = "@srcdir@"
+libdir	      = "@libdir@"
+includedir    = "@includedir@"
 install	      = "@INSTALL@"
 shlib_cflags  = "@SHLIB_CFLAGS@"
@@ -57,5 +59,5 @@
 f.printf("CFLAGS        = #{cxxflags}\n")
 f.printf("CXX_DLFLAGS   = #{cxx_dlflags}\n")
-f.printf("INCLUDES      = -I$(incdir) -I#{srcdir}/../../src/core -I$(archdir)/\n")
+f.printf("INCLUDES      = -I$(incdir) -I#{includedir} -I$(archdir)/\n")
 f.printf("INSTALL       = #{install}\n")
 f.printf("SHLIB_FLAGS   = $(CFLAGS) $(CXX_DLFLAGS) $(LDFLAGS) $(INCLUDES)\n\n")
@@ -63,5 +65,5 @@
 f.printf("SHLIB_LD      = #{ldshared}\n")
 f.printf("LDFLAGS	= #{ldflags}\n")
-f.printf("LIBS          = -L../../src/core -lrappture #{libs}\n\n")
+f.printf("LIBS          = -L#{libdir} -lrappture #{libs}\n\n")
 f.printf("package	= $(TARGET).$(DLEXT)\n\n")
 f.printf("all: extension\n\n")
Index: branches/r9/lang/tcl/src/Makefile.in
===================================================================
--- branches/r9/lang/tcl/src/Makefile.in	(revision 4853)
+++ branches/r9/lang/tcl/src/Makefile.in	(revision 4861)
@@ -32,9 +32,7 @@
 CXX_SWITCHES    = $(CFLAGS) $(CFLAGS_DEBUG) $(INCLUDES) $(DEFINES)
 
-INCLUDES    = -I$(srcdir) \
-  -I../../../src/core \
-  -I$(srcdir)/../../../src/core \
-  -I$(srcdir)/../../../src/objects \
-  -I$(includedir)
+INCLUDES    	= -I$(srcdir) \
+		  -I$(includedir) 
+
 RAPPTURE_VERSION = @PACKAGE_VERSION@
 SVN_VERSION     := $(shell svnversion $(srcdir))
@@ -49,7 +47,7 @@
 CDEBUGFLAGS     = -g -Wall
 
-LIBS = \
-        -L../../../src/core -lrappture \
-        $(TCL_LIB_SPEC) -lexpat -lz -lm -lstdc++
+LIBS 		= \
+        	-L$(libdir) -lrappture \
+	        $(TCL_LIB_SPEC) -lexpat -lz -lm -lstdc++
 
 OBJS = \